/**
 * AP_Types.h
 *
 * Define a common set of type names across all supported platforms, with names
 * that can safely be exported into third-party code C/C++ code.
 *
 * $Copyright(c) 2002, 2004-2006, 2009, 2012 Progress Software Corporation (PSC). All rights reserved.$
 * $Copyright (c) 2013-2014, 2022 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$
 * Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG
 *
 */

#ifndef AP_TYPES_H
#define AP_TYPES_H

#include <stddef.h>

#ifdef _WIN32

typedef __int64 AP_int64;
typedef unsigned __int64 AP_uint64;

typedef long AP_int32;
typedef unsigned long AP_uint32;

typedef short AP_int16;
typedef unsigned short AP_uint16;

typedef char AP_int8;
typedef unsigned char AP_uint8;

typedef double AP_float64;

typedef char AP_char8;
typedef wchar_t AP_char16;

typedef unsigned char AP_bool;

#endif /* _APBUILD_WIN32_ALL__ || __WIN32__ */


#if defined(_APBUILD_UNIX_ALL__) || defined(__unix__)

#include <inttypes.h>

typedef int64_t AP_int64;
typedef uint64_t AP_uint64; 

typedef int32_t AP_int32;
typedef uint32_t AP_uint32;

typedef double AP_float64;

typedef char AP_char8;
typedef unsigned short AP_char16;

typedef short AP_int16;
typedef unsigned short AP_uint16;

typedef char AP_int8;
typedef unsigned char AP_uint8;

typedef unsigned char AP_bool;

#endif /* _APBUILD_UNIX_ALL__ || __unix__ */

typedef AP_uint64 AP_decimal;

#define AP_TRUE ((AP_bool)1)
#define AP_FALSE ((AP_bool)0)


#endif /* AP_TYPES_H */
