/*
 * Title:        sag_internal/exception.hpp
 * Description:  Internal exception handling utility code
 * $Copyright (c) 2015-2016, 2020, 2022 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$
 * Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG
 */


#ifndef _SAG_INTERNAL_EXCEPTION_HPP_
#define _SAG_INTERNAL_EXCEPTION_HPP_

namespace com {
namespace softwareag {
namespace _DATAT_INTERNAL_CPP_NAMESPACE { 

/** @internal
 * For use in catch blocks. Logs an in-progress exception with the given logger.
 */
inline void handleException(const Logger &logger, Logger::level_t level, const char *method)
{
	try {
		throw; 
	} catch (const std::exception &e) {
		logger.log(level, "Exception from %s: %s", method, e.what());
	} catch (...) {
		logger.log(level, "Unknown exception from %s", method);
	}
}


}}} // com.softwareag.connectivity

#endif // _SAG_INTERNAL_EXCEPTION_HPP_
